<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader :is-auth="true" :is-statuser="true" powerData="new_cabin_button" @addForm="addForm">
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">舱位管理</div>
          </div>
        </template>
      </Minheader>
      <div class="app-containers">
        <DataTable :tableHeader="tableCols" :tableData="tableData" :tableBtnGroup="tableBtnGroup" :tableProperty="{ rowKey: 'ID' }" @btnClick="btnClick" />
      </div>
      <Dialog :flag="flag" :type="type" :msgTitle="msgTitle" :delName="tableForm.storingName" @resetForm="resetForm" @delRest="delRest" @submitForm="submitForm" @delRemove="delRemove">
        <div class="diacont">
          <el-form :model="tableForm" :rules="formRules" ref="shippingSpaceForm">
            <el-row :gutter="24">
              <el-col>
                <el-form-item label="机型ID" prop="binNo" :rules="formRules.isNotNull" size="default">
                  <el-input v-model="tableForm.binNo" placeholder="请输入机型ID" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="舱位ID" prop="storingID" :rules="formRules.isNotNull" size="default">
                  <el-input v-model="tableForm.storingID" placeholder="请输入舱位ID" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="机型名称" size="default">
                  <el-input disabled v-model="tableForm.modelName" placeholder="请输入机型名称" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="舱位名称" size="default" prop="storingName" :rules="formRules.isNotNull">
                  <el-input v-model="tableForm.storingName" placeholder="请输入舱位名称" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="舱位编码" size="default" prop="storingCode" :rules="formRules.isNotNull">
                  <el-input v-model="tableForm.storingCode" placeholder="请输入舱位编码" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="备注" size="default">
                  <el-input v-model="tableForm.storingDesc" placeholder="请输入备注" />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
const formRules = useElement().formRules;
const route = useRoute();
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<boolean>(false);
const rowTitle = ref<string>("");
const tableCols = ref<any>([]); //表头数据
const serviceId = ref<any>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<boolean>(false); //弹窗开关
const type = ref<string>(""); //判断是否删除
const msgTitle = ref<string>("新增舱位管理"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗
const tableForm = reactive<any>({
  storingID: "",
  storingName: "",
  storingCode: "",
  storingDesc: "",
  binNo: "",
  modelName: "",
  event: "",
}); //弹窗内容
tableForm.binNo = route.query.modelID;
tableForm.modelName = route.query.modelName;
//列表
const tableData = ref<any>([]);
//表头
const state = reactive({
  list: [
    { label: "舱位名称", key: "name" },
    { label: "舱位编码", key: "china" },
    { label: "舱位描述", key: "englin" },
  ],
  listLoading: true,
});
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "cabin_editor_button",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "cabin_deletion_button",
  },
]);
//新增
const addForm = () => {
  msgTitle.value = "新增舱位管理";
  tableForm.event = 1;
  flag.value = true;
  type.value = "";
};
//取消
const resetForm = () => {
  shippingSpaceForm.value?.resetFields();
  flag.value = false;
  // tableForm.storingID = "";
  // tableForm.storingName = "";
  // tableForm.storingCode = "";
  // tableForm.storingDesc = "";
};
//编辑
const editDialog = (data) => {
  msgTitle.value = "编辑舱位管理";
  flag.value = true;
  type.value = "";
  tableForm.name = data.name;
  tableForm.china = data.china;
  tableForm.englin = data.englin;
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除舱位管理";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  const obj = {
    storingID: tableForm.storingID,
    event: 3,
  };
  generalDataReception(obj);
};
//删除
const delRest = () => {
  flag.value = false;
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑舱位管理";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.storingID = index.storingID;
    tableForm.storingName = index.storingName;
    tableForm.storingCode = index.storingCode;
    tableForm.storingDesc = index.storingDesc;
  } else if (param === 3) {
    msgTitle.value = "删除舱位管理";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.storingID = index.storingID;
    tableForm.storingName = index.storingName;
    tableForm.storingCode = index.storingCode;
    tableForm.storingDesc = index.storingDesc;
  } else if (param === 4) {
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.shippingNodeId,
      needPage: ++page.value,
      dataContent: [route.query.modelID],
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableData.value.forEach((element) => {
        element.modelName = route.query.modelName;
      });
      tableCols.value = returnData.columnSet;
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
//确认提交
const shippingSpaceForm: any = ref(null);
const submitForm = () => {
  shippingSpaceForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};

const btnAuthMap = [
  ,
  "new_cabin_button",
  "cabin_editor_button",
  "cabin_deletion_button",
];
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    let obj = {
      IATACode: route.query.modelID,
    };
    data = {
      ...data,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
      btnAuth: btnAuthMap[data.event],
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 80px;
}
</style>
